var path = require('path');

var config = {
    ROOT_PATH: process.env.ROOT_PATH ? process.env.ROOT_PATH : path.join(__dirname, '../../'),
    GIT_BRANCH: process.env.GIT_BRANCH,
    DEPLOY_BRANCHES: process.env.DEPLOY_BRANCHES ? process.env.DEPLOY_BRANCHES.split(',') : ['origin/development', 'origin/staging', 'origin/master'],
    NAME_BRANCHES: process.env.NAME_BRANCHES ? process.env.NAME_BRANCHES.split(',') : ['development', 'staging', 'production'],
    AWS: {
        "AWS_ACCESS_KEY_ID": process.env.AWS_ACCESS_KEY_ID,
        "AWS_SECRET_ACCESS_KEY": process.env.AWS_SECRET_ACCESS_KEY,
        "S3_BUCKET_CODE": process.env.S3_BUCKET_CODE,
        "S3_BUCKET_CF": process.env.S3_BUCKET_CF,
        "REGION": process.env.REGION,
        "URL_BASE": "https://s3.amazonaws.com/"
    },
    EXCLUDE_FOLDER: process.env.EXCLUDE_FOLDER ? process.env.EXCLUDE_FOLDER.split(',') : []
};

config.LAMBDA_PATH = process.env.LAMBDA_PATH ? process.env.LAMBDA_PATH : path.join(config.ROOT_PATH, 'lambda');
config.CF_PATH = process.env.CF_PATH ? process.env.CF_PATH : path.join(config.ROOT_PATH, 'provisioning');

module.exports = config;