var s3Handler = require('../UploadS3/s3Handler'),
    config = require('../../config'),
    logger = require('../../helper/logger'),
    async = require('async'),
    fs = require('fs'),
    path = require('path'),
    _ = require('lodash');

module.exports = function (provisioningPath, currentBranch, done) {
    fs.readdir(provisioningPath, function (err, files) {
        if(err)
            return done({code: 'ReadDirectory', detail: err});
        
        async.map(files, iteratee(provisioningPath, currentBranch), done);
    })
};


function iteratee(provisioningPath, currentBranch) {
    return function (file, next) {
        var pathObj = path.parse(file);
        if(pathObj.ext != '.json') {
            return next(null, {stage: 'InvalidExt', message: 'Provisioning should be a json file'});
        }
    
        var pathFile = path.join(provisioningPath, pathObj.base);
        var s3Path = path.join(currentBranch, pathObj.base);
        logger.log("UPLOAD CF STACK");
        logger.log("Path file: "+ pathFile);
        logger.log("Path s3: "+ s3Path);
        s3Handler.uploadFile(pathFile, s3Path, config.AWS.S3_BUCKET_CF, next);
    };
}