var async = require('async');
var path = require('path');
var _ = require('lodash');
var child_process = require('child_process');
var logger = require('../../helper/logger');

var errors = [];

module.exports = function (scripts, done) {
    var iteratee = function (value, key, cb) {
        executeNPMScript(key, cb);
    };
    async.mapValuesSeries(scripts, iteratee, function (err, result) {
        if(!_.isEmpty(errors)){
            return done(errors)
        }
        
        done();
    })
};




function executeNPMScript(script, done) {
    var cmd = "npm run-script "+script;
    child_process.exec(cmd, function (err, stdout, stderr) {
        logger.log(stdout);
        if(err)
            errors.push(err);
        done();
    })
}