var zipHandler = require('./zipHandler'),
    s3Handler = require('./s3Handler'),
    config = require('../../config'),
    async = require('async'),
    fs = require('fs'),
    path = require('path'),
    _ = require('lodash');

module.exports = function (branch, dirName, fileName, done) {
    async.auto({
        generateZip: function (cb) {
            zipHandler.generateZip(dirName, fileName, cb);
        },
        uploadFile: ['generateZip', function (result, cb) {
            var s3Path = dirName.split('/lambda/')[1];
            s3Path = path.dirname(s3Path);
            s3Path = path.join(branch, s3Path);
            s3Path = path.join(s3Path, result.generateZip.fileName + '.zip');
            s3Handler.uploadFile(result.generateZip.zipPath, s3Path, config.AWS.S3_BUCKET_CODE, cb);
        }],
        removeZip: ['generateZip', 'uploadFile', function (result, cb) {
            zipHandler.removeZip(result.generateZip.zipPath, cb);
        }]
    }, done);
};
