var config = require('../../config'),
    aws = require('aws-sdk'),
    fs = require('fs');

aws.config.update({
    accessKeyId: config.AWS.AWS_ACCESS_KEY_ID,
    secretAccessKey: config.AWS.AWS_SECRET_ACCESS_KEY
});

aws.config.region = config.AWS.REGION;

function uploadFile(filePath, s3Path, bucket, next) {
    try {
        var body = fs.createReadStream(filePath);
        
        var s3obj = new aws.S3({params: {Bucket: bucket, Key: s3Path}});
        s3obj
            .upload({Body: body, ContentType: 'application/octet-stream'})
            .send(function(err, data) {
                if (err)
                    return next({code: 'UploadFileS3', detail: err});

                next(null, {filePath: filePath, detail: data});
            });
    } catch (err) {
        next({code: 'CatchError', detail: err});
    }
}

exports.uploadFile = uploadFile;