var fs = require('fs'),
    archiver = require('archiver');


function generateZip(dirname, fileName, done){
    var zipPathFile = dirname + '/' + fileName + '.zip';
    var output = fs.createWriteStream(zipPathFile);
    var archive = archiver('zip');
    
    output.on('close', function () {
        return done(null, {zipPath: zipPathFile, fileName: fileName});
    });
    
    archive.on('error', function(err){
        return done({stage: 'WriteZip', detail:err});
    });
    
    archive.pipe(output);
    archive.directory(dirname, false);
    archive.finalize();
}

function removeZip(filePath, done) {
    fs.unlink(filePath, done);
}

exports.generateZip = generateZip;
exports.removeZip = removeZip;