var sinon = require('sinon');
var expect = require('chai').expect;
var path = require('path');
var config = require('../../config');
var zipHandler = require('../../lib/UploadS3/zipHandler');
var _ = require('lodash');


describe('Upload S3 - zipHandler', function () {
    
    it('Zip file and remove it', function (done) {
        var fileName = 'ziptest';
        var filePath = path.resolve(__dirname, '../example');
        zipHandler.generateZip(filePath, fileName, function (err, result) {
            expect(err).to.not.exist;
            expect(result).to.exist;
        
            expect(result.zipPath).to.equal(path.resolve(__dirname, '../example/' + fileName + '.zip'));
            expect(result.fileName).to.equal(fileName);
        
            zipHandler.removeZip(result.zipPath, function (err) {
                expect(err).to.not.exist;
                done();
            });
        });
    });
});