var _ = require('lodash');
var async = require('async');
var fs = require('fs');
var path = require('path');
var rimraf = require('rimraf');


before(function (done) {
    async.series([
        function (cb) {
            rimraf(path.resolve(__dirname, 'example'), function () {
                cb();
            });
        },
        function (cb) {fs.mkdir(path.resolve(__dirname, 'example'), cb); },
        function (cb) { fs.appendFile(path.resolve(__dirname, 'example/package.json'), "{\"scripts\": {}}", {flag: 'w'}, cb); },
        function (cb) { fs.mkdir(path.resolve(__dirname, 'example/provisioning'), cb)},
        function (cb) { fs.appendFile(path.resolve(__dirname, 'example/provisioning/service1.json'), "{}", {flag: 'w'}, cb); },
        function (cb) { fs.appendFile(path.resolve(__dirname, 'example/provisioning/service2.json'), "{}", {flag: 'w'}, cb); },
        function (cb) { fs.mkdir(path.resolve(__dirname, 'example/lambda'), cb)},
        function (cb) { fs.mkdir(path.resolve(__dirname, 'example/lambda/d1'), cb)},
        function (cb) { fs.mkdir(path.resolve(__dirname, 'example/lambda/d1_1'), cb)},
        function (cb) { fs.mkdir(path.resolve(__dirname, 'example/lambda/d2'), cb)},
        function (cb) { fs.mkdir(path.resolve(__dirname, 'example/lambda/d2/d2_1'), cb)},
        function (cb) { fs.appendFile(path.resolve(__dirname, 'example/file.txt'), "Hello world", {flag: 'w'}, cb); },
        function (cb) { fs.appendFile(path.resolve(__dirname, 'example/lambda/d1/package.json'), "{}", {flag: 'w'}, cb); },
        function (cb) { fs.appendFile(path.resolve(__dirname, 'example/lambda/d2/d2_1/package.json'), "{}", {flag: 'w'}, cb); }
    ], done);
});

after(function (done) {
    rimraf(path.resolve(__dirname, 'example'), function (err) {
        done(err);
    });
});
